<template>
  <div>
    <img alt="Vue logo" src="@/assets/logo.png">
    <div>
      <h3 style="margin-bottom: 0px">Пользователь</h3>
      <div>Id: {{ user.profile.sub }}</div>
      <div>Имя: {{ user.profile.FirstName }}</div>
      <div>Фамилия: {{ user.profile.LastName }}</div>
      <div>Email: {{ user.profile.email }}</div>
      <div>Токен действителен до: {{ new Date(user.expires_at * 1000).toLocaleString() }}</div>
    </div>
    <div>
      <h3 style="margin-bottom: 0px">Права</h3>
      <div v-for="p in permissions" :key="p.id">{{ p.name }}</div>
    </div>
    <br/>
    <div>закрытая страница</div>
    <button @click="signOut">Sign out</button>
    <button @click="renew">Renew token</button>
    <button @click="getValues">Get values</button>
    <button @click="getValue">Get value</button>
    <button @click="postValue">Post value</button>
    <button @click="putValue">Put value</button>
    <button @click="deleteValue">Delete value</button>

    <div v-if="loading">Loding</div>
    <div style="margin-top: 10px;" v-else>
      <ul v-if="Array.isArray(value)">
        <li v-for="(v, i) in value" :key="i">{{ v }}</li>
      </ul>
      <div v-else>
        {{ value }}
      </div>
    </div>
  </div>
</template>

<script>
import security from '../services/security';
export default {
  data: () => ({
    value: []
  }),
  computed: {
    loading(){
      return this.$store.getters.getLoading
    },
    user(){
      return this.$store.getters.getUser
    },
    permissions(){
      return this.$store.getters.getPermissions
    }
  },
  watch: {
    user(user) {
      if(!user){
        this.$router.push({name: 'home'})
      }
    }
  },
  methods: {
    signOut(){
      security.signOut()
    },
    renew(){
      this.$store.dispatch('renewToken')
    },
    getValues(){
      this.$store.dispatch('getValues').then(response => {
        this.value = response
      }).catch(error => {
        if(error.response.status){
          this.value = '403 not access'
        } else {
          this.value = 'error'
        }
      })
    },
    getValue(){
      this.$store.dispatch('getValue', 1).then(response => {
        this.value = response
      }).catch(error => {
        if(error.response.status){
          this.value = '403 not access'
        } else {
          this.value = 'error'
        }
      })
    },
    postValue(){
      this.$store.dispatch('postValue', { 'data': 'test' }).then(() => {
        this.value = "success"
      }).catch(error => {
        if(error.response.status){
          this.value = '403 not access'
        } else {
          this.value = 'error'
        }
      })
    },
    putValue(){
      this.$store.dispatch('putValue', {id: 1, payload: { 'data': 'test' }}).then(() => {
        this.value = "success"
      }).catch(error => {
        if(error.response.status){
          this.value = '403 not access'
        } else {
          this.value = 'error'
        }
      })
    },
    deleteValue(){
      this.$store.dispatch('deleteValue', 1).then(() => {
        this.value = "success"
      }).catch(error => {
        if(error.response.status){
          this.value = '403 not access'
        } else {
          this.value = 'error'
        }
      })
    }
  }
}
</script>
